[解题报告]376. Wiggle Subsequence

Problem Background:

A sequence of numbers is called a wiggle sequence if the differences between successive numbers strictly alternate between positive and negative. The first difference (if one exists) may be either positive or negative. A sequence with fewer than two elements is trivially a wiggle sequence.

For example, [1,7,4,9,2,5] is a wiggle sequence because the differences (6,-3,5,-7,3) are alternately positive and negative. In contrast,[1,4,7,2,5] and [1,7,4,5,5] are not wiggle sequences, the first because its first two differences are positive and the second because its last difference is zero.

Given a sequence of integers, return the length of the longest subsequence that is a wiggle sequence. A subsequence is obtained by deleting some number of elements (eventually, also zero) from the original sequence, leaving the remaining elements in their original order.

Examples:

Input: [1,7,4,9,2,5]
Output: 6
The entire sequence is a wiggle sequence.

Input: [1,17,5,10,13,15,10,5,16,8]
Output: 7
There are several subsequences that achieve this length. One is [1,17,10,13,10,16,8].

Input: [1,2,3,4,5,6,7,8,9]
Output: 2

Follow up:
Can you do it in O(n) time?

Credits:
Special thanks to @agave and @StefanPochmann for adding this problem and creating all test cases.

Subscribe to see which companies asked this question

  Dynamic Programming Greedy

解体报告:
从Tag可以看出这是一道DP+贪心解法
O(n)时间
1.线性扫描整个数据集
2.维护一个lastNum值,它纪录了上一次连续非单调的最值(最小值或者最大值)
3.每次迭代,和lastNum比较,如果满足wiggle,max加一
Code:
class Solution {
public:
    int wiggleMaxLength(vector& nums) {
        int length = nums.size();
        if (length < 1) {
        	return 0;
        } else if (length == 1) {
        	return 1;
        } else {
        	int max = 1;
        	int lastNum = nums[0];
        	bool isPositive = nums[1] > nums[0] ? true : false;
	        for (int i = 1; i < length; ++i, isPositive = !isPositive) {
	        	if (isPositive) {
		        	if (nums[i] > lastNum) {
		        		++max;
		        	} else {
		        		isPositive = false;
		        	}
	        	} else {
	        		if (nums[i] < lastNum) {
	        			++max;
	        		} else {
		        		isPositive = true;
	        		}
	        	}
				lastNum = nums[i];
	        }
	        return max;
    	}
    }
};



你可能感兴趣的:(Leetcode)